/**
  Generated Main Source File
    Ramen_Timer
   
  Company:
    Microchip Technology Inc.

  File Name:
    main.c

  Summary:
    This is the main file generated using PIC10 / PIC12 / PIC16 / PIC18 MCUs

  Description:
    This header file provides implementations for driver APIs for all modules selected in the GUI.
    Generation Information :
        Product Revision  :  PIC10 / PIC12 / PIC16 / PIC18 MCUs - 1.77
        Device            :  PIC16F18313
        Driver Version    :  2.00
 
  I/O: 
    RA0 - LED(3min) 
    RA1 - LED(4min) 
    RA2 - LED(5min)
    RA3 - Time Select SW 
    RA4 - Timer Start SW 
    RA5 - Buzzer  
*/

/*
    (c) 2018 Microchip Technology Inc. and its subsidiaries. 
    
    Subject to your compliance with these terms, you may use Microchip software and any 
    derivatives exclusively with Microchip products. It is your responsibility to comply with third party 
    license terms applicable to your use of third party software (including open source software) that 
    may accompany Microchip software.
    
    THIS SOFTWARE IS SUPPLIED BY MICROCHIP "AS IS". NO WARRANTIES, WHETHER 
    EXPRESS, IMPLIED OR STATUTORY, APPLY TO THIS SOFTWARE, INCLUDING ANY 
    IMPLIED WARRANTIES OF NON-INFRINGEMENT, MERCHANTABILITY, AND FITNESS 
    FOR A PARTICULAR PURPOSE.
    
    IN NO EVENT WILL MICROCHIP BE LIABLE FOR ANY INDIRECT, SPECIAL, PUNITIVE, 
    INCIDENTAL OR CONSEQUENTIAL LOSS, DAMAGE, COST OR EXPENSE OF ANY KIND 
    WHATSOEVER RELATED TO THE SOFTWARE, HOWEVER CAUSED, EVEN IF MICROCHIP 
    HAS BEEN ADVISED OF THE POSSIBILITY OR THE DAMAGES ARE FORESEEABLE. TO 
    THE FULLEST EXTENT ALLOWED BY LAW, MICROCHIP'S TOTAL LIABILITY ON ALL 
    CLAIMS IN ANY WAY RELATED TO THIS SOFTWARE WILL NOT EXCEED THE AMOUNT 
    OF FEES, IF ANY, THAT YOU HAVE PAID DIRECTLY TO MICROCHIP FOR THIS 
    SOFTWARE.
*/

#include "mcc_generated_files/mcc.h"

#define SW1 RA3                 // ԑIXCb`
#define SW2 RA4                 // ^C}[X^[gXCb`
#define LED3 RA0                // 3LED
#define LED4 RA1                // 4LED
#define LED5 RA2                // 5LED
#define Buz RA5                 // uU[o

// O[oϐ錾
unsigned int Flag;              // LED_ŃtO
unsigned int State;             // ԃXe[g
unsigned long Count;            // ^C}[2JEgϐ

// vg^CsO錾
void TMR2_Interrupt(void);    // ^C}[2荞ݏ֐
void Buzzer(void);             // uU[֐

/*
                         Main application
 */
void main(void)
{
    // initialize the device
    SYSTEM_Initialize();

    TMR2_SetInterruptHandler(TMR2_Interrupt);   // TMR2_Interrupt:[U[荞ݏ֐̒` (tmr2.cQ    
    
    // When using interrupts, you need to set the Global and Peripheral Interrupt Enable bits
    // Use the following macros to:

    // Enable the Global Interrupts
    //INTERRUPT_GlobalInterruptEnable();

    // Enable the Peripheral Interrupts
    INTERRUPT_PeripheralInterruptEnable();      // ӊ荞݋

    // Disable the Global Interrupts
    //INTERRUPT_GlobalInterruptDisable();

    // Disable the Peripheral Interrupts
    //INTERRUPT_PeripheralInterruptDisable();

    // ϐ    
    LED4 = LED5 = 0;            // LED4/5 
    LED3 = 1;                   // LED3 _
    Flag = 0;    
    State = 0;                  // 3ftHg       
    
    while (1)
    {
        // Add your application code
        
        switch(State) {                     // State
            case 0:                         // 3I

                if(SW2 == 0) {              // X^[gSWIH            
                    TMR2IE = 1;             // ^C}[2荞݋
                    GIE = 1;                // O[o荞݋
                    while (SW2 == 0)        // `^O        
                    __delay_ms(25);                        
                }

                if (SW1 == 0) {             // ԑISWIH
                    GIE = 0;                // O[o荞݋֎~
                    State++;                // StateJEgAbv
                    LED4 = 1;               // LED4 _ 
                    while (SW1 == 0)        // `^O        
                    __delay_ms(25);  
                }

                break;

            case 1:                         // 4I

                if(SW2 == 0) {              // X^[gSWIH            
                    TMR2IE = 1;             // ^C}[2荞݋
                    GIE = 1;                // O[o荞݋
                    while (SW2 == 0)        // `^O        
                    __delay_ms(25);                        
                }

                if (SW1 == 0) {        // ԑISWIH
                    GIE = 0;                // O[o荞݋֎~
                    State++;                // StateJEgAbv
                    LED5 = 1;               // LED5 _ 
                    while (SW1 == 0)        // `^O        
                    __delay_ms(25);  
                }

                break;

            case 2:                         // 5I

                if(SW2 == 0) {              // X^[gSWIH            
                    TMR2IE = 1;             // ^C}[2荞݋
                    GIE = 1;                // O[o荞݋
                    while (SW2 == 0)        // `^O        
                    __delay_ms(25);                        
                }
                
                if (SW1 == 0) {             // ԑISWIH
                    GIE = 0;                // O[o荞݋֎~
                    State = 0;              // StateZbg
                    LED3 = 1;               // LED3 _ 
                    while (SW1 == 0)        // `^O        
                    __delay_ms(25);  
                }                
                
                break;
  
            default:break;                
        }
    }
}

// ^C}[2荞ݏ֐
void TMR2_Interrupt(void) {

    Count++;                        // ^C}[2荞݃JEgAbv

// 3^C}[    
    if (State == 0) {               // State=0(3)̏ꍇ

        if (Flag == 0) {
            LED3 = 1;               // LED3 _
            Flag = 1;               // Flag؂ւ
        }

        else {
            LED3 = 0;               // LED3 
            Flag = 0;               // Flag؂ւ            
        }
            
        if (Count >= 360) {         // ^C}[2荞ݎ:500ms -> Count = 60s x 3 x 2
            TMR2IE = 0;             // ^C}[2荞݋֎~
            Buzzer();               // uU[(3)
            Buzzer();               
            Buzzer();                           
            Count = 0;              // CountNA    
            LED3 = 1;               // LED3 _
        }
    }

// 4^C}[     
    if (State == 1) {

        if (Flag == 0) {
            LED4 = 1;               // LED4 _
            Flag = 1;               // Flag؂ւ
        }
        
        else {
            LED4 = 0;               // LED4 
            Flag = 0;               // Flag؂ւ            
        }

        if (Count >= 480) {         // ^C}[2荞ݎ:500ms -> Count = 60s x 4 x 2
            TMR2IE = 0;             // ^C}[2荞݋֎~
            Buzzer();               // uU[(4)
            Buzzer();               
            Buzzer();               
            Buzzer();                           
            Count = 0;              // CountNA    
            LED4 = 1;               // LED4 _
        }        
    }    

// 5^C}[     
    if (State == 2) {

        if (Flag == 0) {
            LED5 = 1;               // LED5 _
            Flag = 1;               // Flag؂ւ
        }

        else {
            LED5 = 0;               // LED5 
            Flag = 0;               // Flag؂ւ           
        }

        if (Count >= 600) {         // ^C}[2荞ݎ:500ms -> Count = 60s x 5 x 2
            TMR2IE = 0;             // ^C}[2荞݋֎~
            Buzzer();               // uU[(5)
            Buzzer();               
            Buzzer();               
            Buzzer();               
            Buzzer();               
            Count = 0;              // CountNA 
            LED5 = 1;               // LED5 _
        }      
    }
}

// uU[֐
void Buzzer(void) {

    Buz = 1;
    __delay_ms(700);        // uU[ON        

    Buz = 0;
    __delay_ms(300);        // uU[OFF      

}

/**
 End of File
*/